#include "sqrt.hpp"
#include <cmath>
#include <stdexcept>

double fabelous_sqrt::sqrt(long long number) {
    if (number < 0) {
        throw std::invalid_argument("Cannot compute square root of a negative number");
    }
    // Special case for 0 and 1
    if (number == 0 || number == 1) {
        return static_cast<double>(number);
    }

    long long x = number;
    double y = static_cast<double>((x + 1) / 2);
    while (y < x) {
        x = static_cast<long long>(y);
        y = (static_cast<double>(x) + static_cast<double>(number) / static_cast<double>(x)) / 2;
    }
    return y;
}